<?php

if (defined("_INC_PUBLIC")) { // inclusion diffre
  $page = inclure_page($fond, $delais, $contexte_inclus);
  if ($page['process_ins'])
    { eval('?' . '>' .  $page['texte']); }
  else
   { 
     echo $page['texte']; 
   }
 } else { // premier appel
  define("_INC_PUBLIC", "1");
  include ("ecrire/inc_version.php3");
  include_ecrire("inc_meta.php3");
  if (!$GLOBALS['db_ok'])
    die ("<h4>"._T('titre_probleme_technique')."</h4>"); 
  if ($INSECURE['fond'] || $INSECURE['delais']) exit;
  if (!isset($delais)) $delais = 1 * 3600;
  if ($GLOBALS['HTTP_COOKIE_VARS']['spip_session'] OR $PHP_AUTH_USER)
    {
      include_ecrire ("inc_session.php3");
      verifier_visiteur();
    }

  function inclure_subpage($fond, $delais_inclus, $contexte_inclus, $cache_incluant)
  {
    // ce perdant de PHP ne comprend pas f(x)[y]
    $page = inclure_page($fond, $delais_inclus, $contexte_inclus, $cache_incluant);
    return $page['texte']; 
  }

  function inclure_page($fond, $delais_inclus, $contexte_inclus, $cache_incluant='')
  {
    global $delais;
    static $pile_delais = '', $ptr_delais = 0;
    $ptr_delais++;
    $pile_delais[$ptr_delais] = $delais_inclus;

  // Inclusion d'un squelette.
  // include PHP dj faits, mais il faut simuler l'appel complet
  // pour que le md5 du cache soit le meme qu'un appel initial cf ci-dessous
   $appel = substr($GLOBALS[PHP_SELF],0, strrpos($GLOBALS[PHP_SELF], '/')+1) .
     $fond;

   if (is_array($contexte_inclus)) {
     reset($contexte_inclus);
     while(list($k, $v) = each($contexte_inclus)) $appel .= "=$v";
   }
   $hache = md5($appel);
   spip_log("Page  inclure dans 0x$cache_incluant: $appel ($hache)");
   $use_cache = '';
   if (($GLOBALS['recalcul'] != 'oui') && empty($HTTP_POST_VARS))
     $use_cache = ramener_cache($hache, 'page_obsolete', 'spip_caches', 
				$delais_inclus);
   if ($use_cache)
     {  
       $page = $use_cache;
     } else {
	     include('inc-calcul.php3');
	     $page = cherche_page($fond, 
				  $hache,
				  $contexte_inclus,
				  $contexte_inclus['id_rubrique']);
	     ecrire_cache($appel, $hache, $page, $pile_delais[$ptr_delais]);
	     }
   if ($cache_incluant) 
     invalideur_de_cache(array("0x$hache" => true), 
			 'inclure',
			 $cache_incluant);
   // si son dlai est + court que l'incluant, il prdomine
   if ($ptr_delais == 1)
     { if ($delais > $pile_delais[$ptr_delais])
	 $delais = $pile_delais[$ptr_delais]; }
   else
     { 
       if ($pile_delais[$ptr_delais-1] > $pile_delais[$ptr_delais])
	 $pile_delais[$ptr_delais-1] = $pile_delais[$ptr_delais];
     }
    $ptr_delais--;
   // marche pas dans le cas d'un cache en fichier. A finir.
  $page['texte'] = admin_page($page['texte'], $use_cache);
  return $page;
  }

function admin_page($texte, $cached)
{
  $admin = $GLOBALS['HTTP_COOKIE_VARS']['spip_admin'];
  
 // insertion du JS juste avant la balise </head>, 
 // s'il n'y en a pas, ne rien faire: attendre l'include qui doit l'avoir

 if ($head = stristr($texte, "</head"))
   {
 // Le bouton des administrateurs est affich par une fonction JavaScript
 // non mise en cache car dpendant de l'utilisateur (pas d'affichage parfois)
 // Elle est appele par le code d'un squelette utilisant FORMULAIRE_ADMIN
 // Elle est aussi appele d'autorit si flag_preserver est Vrai,
 // aussi elle se neutralise au premier appel pour ne pas afficher 2 fois.
     
     if  ($admin)
       {
	 include_local('inc-admin.php3');
	 $admin = addslashes(str_replace("\n", ' ', 
			 afficher_boutons_admin($cached ? ' *' : '')));
       }

     $texte = substr($texte,0,strlen($texte)-strlen($head)) .
      "<script language='text/javascript'><!--
	bouton_admin = \"" .
      $admin .
      "\"
	function admin() {document.write(bouton_admin); bouton_admin=''}" .
      "\n//--></script>\n" .
       $head;
   }

 if ($flag_preserver && (stripos($texte, "</body")))
   $texte .= "<script language='text/javascript'><!--\nadmin()\n//--></script>";
 return $texte;
}

// Une petite fonction de trace qui devrait etre dans inc_db_mysql

function spip_query_log($r)
{
  $l = spip_query($r); 
  $e = mysql_info(); # absent de certaines versions de MySQL
  spip_log($r .  $e);
  return $l;
}

// ajout_forum est une HTTP_GET_VAR installe par retour_forum dans inc-forum.
// Il s'agit de pirater les HTTP_POST_VARS, afin de mettre en base
// les valeurs transmises, avant raffichage du formulaire avec celles-ci.
// En cas de validation finale a redirige vers l'URL ayant provoqu l'appel
// au lieu de laisser l'URL appele resynthtiser le formulaire.
  if ($ajout_forum) {
    $redirect = '';
    include('inc-messforum.php3');
    if ($redirect)
      {
	header("Location: $redirect");
	flush();
	exit;
      }
#    include('inc-forum.php3'); pour plus tard
  }
  
// nettoyage de l'URL pour avoir un nom de cache compatible avec les include

  $appel = eregi_replace('.php3?\??','&', $PHP_SELF);
  $appel .= eregi_replace('&(submit|valider|PHPSESSID|(var_[^=&]*)|recalcul)=[^&]*',  '', $QUERY_STRING);
  $appel = eregi_replace('&[^=]*=','=',$appel);
  $hache = md5($appel);
  $use_cache = '';
  $headers_only = ($HTTP_SERVER_VARS['REQUEST_METHOD'] == 'HEAD');

// pas de cache si :
// recalcul (par dfinition) 
// ou si valeurs hors URL (i.e. POST) sauf Forum qui les traite  part
  $forcecalcul = ($GLOBALS['recalcul'] == 'oui') || 
    ($HTTP_POST_VARS && !$ajout_forum);

  include_local ("inc-cache.php3");

if ($headers_only || ($HTTP_IF_MODIFIED_SINCE && !$forcecalcul))
    {
      $lastmodified = cv_du_cache($hache);
      $gmoddate = gmdate("D, d M Y H:i:s", $lastmodified);
      // Code inoprant si le serveur HTTP traite ce champ en amont.
     if ($HTTP_IF_MODIFIED_SINCE)
       {
	 $if_modified_since = ereg_replace(';.*$', '', $HTTP_IF_MODIFIED_SINCE);
	 if (trim(str_replace('GMT', '', $if_modified_since)) == $gmoddate) {
	   http_status(304);
	   $headers_only = true;
	 }
       }
    }

if ($headers_only)
   {
     Header("Last-Modified: ".$gmoddate." GMT");
     flush(); // rien  dire de plus
   }
else
   {
     if (!$forcecalcul)
       {
	 $use_cache = ramener_cache($hache, 'page_obsolete', 'spip_caches', $delais);
       }
     if (!$use_cache)
       {
	 $page = '';
    // Gestion '=chapo' (redirection)
    // + ne pas cacher si l'URL d'un article est demande avant sa publication
    // (une seule requete, deux usages)
	 if ($id_article = intval($id_article)) {
	   $row = spip_fetch_array(spip_query("
SELECT	chapo
FROM	spip_articles
WHERE	id_article='$id_article' AND statut='publie'
"));
	   if (substr($row['chapo'], 0, 1) == '=') {
	     include_ecrire('inc_texte.php3');
	
	     list(,$redirect) = extraire_lien(array('','','',substr($row['chapo'], 1)));
	     if ($redirect) // sinon les navigateurs pataugent
	       {
		 $redirect = 'Location: ' . addslashes($redirect);
# Normalement on devrait pouvoir mettre a en cache:
#	 $page = "<". "?php header(\"$redirect\"); ?" . ">";
# Mais, contrairement  ce que dit sa doc,
# PHP ne met pas toujours le http-status  302 dans ce cas.
# On est donc oblig de refuser la mise en cache:
# et comme le flush ne suffit pas il faut carrment sortir !
		 header($redirect);
		 exit;
	       }
	   }
	 }
	 spip_log("Page principale: $appel ($hache) " . strlen($page));
	 if (!$page)
	   {
	     include('inc-calcul.php3');
	     $page = calculer_page_globale($fond, $hache, $var_recherche);
	   }
	 ecrire_cache($appel, $hache, $page, $delais);
       }
 if (!$page) $page = $use_cache;
 $lastmodified = $use_cache['naissance'];
 if (!$lastmodified) $lastmodified = time();

     // interdire au client de cacher un login, un admin ou un recalcul
 if (!$flag_dynamique && $recalcul != 'oui' && !$HTTP_COOKIE_VARS['spip_admin'])
   $expire = gmdate("D, d M Y H:i:s", $lastmodified + $delais)." GMT";
 else {
  $expire = "0";
  Header("Cache-Control: no-cache,must-revalidate");
  Header("Pragma: no-cache");
 }
 Header("Expires: $expire");
 Header("Last-Modified: ".gmdate("D, d M Y H:i:s", $lastmodified)." GMT");
 Header("Content-Type: text/html; charset=".lire_meta('charset'));
 
 $texte = admin_page($page['texte'], $use_cache);
 if ($page['process_ins'])
    {if ($page['type'] == 'file') 
 // marche pas, a finir
	include($texte); 
      else eval('?' . '>' . $texte);}
 else
   { 
     if ($page['type'] == 'file') 
       $n = readfile($texte);
# L'envoi du content-Length ci-dessous permet d'envoyer d'autres rponses
# dans le cadre des connexions persistantes de HTTP1
# Elle doit s'accompagner du connection-close sinon
# elle retarde l'affichage de certains navigateurs.
# On l'a dsactiv ici puisqu'il n'y a qu'une seule rponse, 
# en laissant le serveur calculer a et dcider de fermer la connexion
# header("Content-Length: " . strlen($texte));
# header("Connection: close");
     else
       {
	 echo $texte; 
	 $n = strlen($texte);
       }
     spip_log("Page 100% HTML (" . $n  . " octets)");
   }
 flush();
 $rienfoutu = $use_cache;

// indexer ce qu'on vient d'envoyer si ce n'est pas dj fait

 if ((lire_meta('activer_moteur') == 'oui') && $db_ok) {
  if ($id_article AND (1 >= spip_num_rows(spip_query("
SELECT	id_article
FROM	spip_index_articles 
WHERE	id_article=$id_article
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('article', $id_article);
      $rienfoutu = false;
    }
  else { if ($id_auteur AND (1 >= spip_num_rows(spip_query("
SELECT	id_auteur
FROM	spip_index_auteurs
WHERE	id_auteur=$id_auteur
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('auteur', $id_auteur);
      $rienfoutu = false;
    }
  else { if ($id_breve AND (1 >= spip_num_rows(spip_query("
SELECT	id_breve
FROM	spip_index_breves
WHERE	id_breve=$id_breve
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('breve', $id_breve);
      $rienfoutu = false;
    }
  else { if ($id_mot AND (1 >= spip_num_rows(spip_query("
SELECT	id_mot
FROM	spip_index_mots
WHERE	id_mot=$id_mot
LIMIT 2
"))))
    { 
      include_ecrire("inc_index.php3");
      indexer_objet('mot', $id_mot);
      $rienfoutu = false;
    }
  else { if ($id_rubrique AND (1 >= spip_num_rows(spip_query("
SELECT	id_rubrique
FROM	spip_index_rubriques
WHERE	id_rubrique=$id_rubrique
LIMIT 2
"))))
    {
      include_ecrire("inc_index.php3");
      indexer_objet('rubrique', $id_rubrique); 
      $rienfoutu = false;
    }
  }}}}}
   } // fin de if (headers_only)
// excuter les taches de fond si on n'a rien eu a recalculer
 if ($rienfoutu)
   include("inc-public-global.php3");
} // fin du defined
?>